﻿using System.Web.Mvc;
using System;
using System.Collections.Generic;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.DataSources;
using System.Collections;
using EJGrid.Models;
using System.Linq;
using Syncfusion.EJ.Export;
using Syncfusion.XlsIO;
using Syncfusion.JavaScript.Models;
using System.Web.Script.Serialization;
using System.Reflection;

namespace EJGrid.Controllers
{
    public class HomeController : Controller
    {

       
        public ActionResult Index()
        {
            var DataSource = OrderRepository.GetAllRecords().ToList();
            ViewBag.datasource = DataSource;
            return View();
        }

        public void ExportToExcel(string GridModel)
        {
            ExcelExport exp = new ExcelExport();
            var DataSource = OrderRepository.GetAllRecords().ToList();
            GridProperties obj = ConvertGridObject(GridModel);
            exp.Export(obj, DataSource, "Export.xlsx", ExcelVersion.Excel2010, false, false, "flat-saffron");
        }

        private GridProperties ConvertGridObject(string gridProperty)
        {
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            IEnumerable div = (IEnumerable)serializer.Deserialize(gridProperty, typeof(IEnumerable));
            GridProperties gridProp = new GridProperties();
            foreach (KeyValuePair<string, object> ds in div)
            {
                var property = gridProp.GetType().GetProperty(ds.Key, BindingFlags.Instance | BindingFlags.Public | BindingFlags.IgnoreCase);
                if (property != null)
                {
                    Type type = property.PropertyType;
                    string serialize = serializer.Serialize(ds.Value);
                    object value = serializer.Deserialize(serialize, type);
                    property.SetValue(gridProp, value, null);
                }
            }
            return gridProp;
        }


        public ActionResult Update(EditableOrder value)
        {
            OrderRepository.Update(value);
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public ActionResult Insert(EditableOrder value)
        {
            OrderRepository.Add(value);
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public ActionResult Delete(int key)
        {
            OrderRepository.Delete(key);
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }


        public ActionResult Employee()
        {
            var data = OrderRepository.GetAllRecords().Select(o => new Employees
            {
                ID = o.OrderID,
                EmployeeID = o.EmployeeID
            }).Distinct().ToList();

            return Json(data, JsonRequestBehavior.AllowGet);
        }

        public ActionResult Customer()
        {
            var data = OrderRepository.GetAllRecords().Select(o => new Customers
            {
                ID = o.OrderID,
                CustomerID = o.CustomerID
            }).Distinct().ToList();

            return Json(data, JsonRequestBehavior.AllowGet);
        }

        public ActionResult City()
        {
            var data = OrderRepository.GetAllRecords().Select(o => new Cities
            {
                ID = o.OrderID,
                ShipCity = o.ShipCity
            }).Distinct().ToList();

            return Json(data, JsonRequestBehavior.AllowGet);
        }

        public class Employees
        {
            public int? EmployeeID { get; set; }
            public int? ID { get; set; }
        }

        public class Customers
        {
            public string CustomerID { get; set; }
            public int? ID { get; set; }
        }

        public class Cities
        {
            public string ShipCity { get; set; }
            public int? ID { get; set; }
        }


    }
}
