﻿namespace EJGrid.Models
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Web;
    using EJGrid.Models;
    using System.Data.SqlClient;
    using System.Data;

    
    public static class OrderRepository
    {
        public class Employee
        {

            public long EmployeeID { get; set; }

            public string FirstName { get; set; }
            public string LastName { get; set; }
        }
        public static IList<EditableOrder> GetAllRecords()
        {
            IList<EditableOrder> orders = (IList<EditableOrder>)HttpContext.Current.Session["Orders"];

            if (orders == null)
            {
                HttpContext.Current.Session["Orders"] = orders = (from ord in new NorthwindDataContext().Orders.Take(100)
                                                                  select new EditableOrder
                                                                  {
                                                                      OrderID = ord.OrderID,
                                                                      OrderDate = ord.OrderDate,
                                                                      CustomerID = ord.CustomerID,
                                                                      EmployeeID = ord.EmployeeID,
                                                                      Freight = ord.Freight,
                                                                      ShipAddress = ord.ShipAddress,
                                                                      ShipCity = ord.ShipCity,
                                                                      ShipName = ord.ShipName,
                                                                      ShipPostalCode = ord.ShipPostalCode,
                                                                      ShipRegion = ord.ShipRegion,
                                                                      ShipCountry = ord.ShipCountry
                                                                  }).ToList();
                foreach (var order in orders)
                {
                    order.ComplexProp = new ComplexProp() { OrderID = order.OrderID };
                    if (order.Freight > 30)
                        order.Verified = true;
                    else
                        order.Verified = false;
                }
            }
            return orders;
        }

        public static void Add(EditableOrder temp)
        {
        //    foreach(var temp in order)
            GetAllRecords().Insert(0, temp);
        }

        public static void Delete(int key)
        {
                EditableOrder result = GetAllRecords().Where(o => o.OrderID == key).FirstOrDefault();
                GetAllRecords().Remove(result);
        }

        public static void Update(EditableOrder temp)
        {
                EditableOrder result = GetAllRecords().Where(o => o.OrderID == temp.OrderID).FirstOrDefault();
                if (result != null)
                {
                    result.OrderID = temp.OrderID;
                    result.CustomerID = temp.CustomerID;
                    result.EmployeeID = temp.EmployeeID;
                    result.OrderDate = temp.OrderDate;
                    result.ShipAddress = temp.ShipAddress;
                    result.ShipCity = temp.ShipCity;
                    result.ShipCountry = temp.ShipCountry;
                    result.ShipName = temp.ShipName;
                    result.ShipRegion = temp.ShipRegion;
                    result.ShipPostalCode = temp.ShipPostalCode;
                    result.Freight = temp.Freight;
                    result.Verified = temp.Verified;
                }
        }

        
    }
}
